%global opt %(test -x %{_bindir}/ocamlopt && echo 1 || echo 0)
%global debug_package %{nil}

Name:           ocaml-bisect
Version:        1.0
Release:        1%{?dist}
Summary:        OCaml code coverage tool

Group:          Development/Libraries
License:        GPLv3+
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExcludeArch:    sparc64 s390 s390x

URL:            http://bisect.x9c.fr/
Source0:        http://bisect.x9c.fr/distrib/bisect-%{version}.tar.gz

Patch0:         bisect-1.0-thread.patch

BuildRequires:  ocaml >= 3.10.0
BuildRequires:  ocaml-findlib-devel
BuildRequires:  ocaml-ocamldoc
BuildRequires:  ocaml-camlp4-devel

%global __ocaml_requires_opts -i Asttypes -i Parsetree


%description
Bisect is a code coverage tool for the Objective Caml language. It is
a camlp4-based tool that allows to instrument your application before
running tests. After application execution, it is possible to generate
a report in HTML format that is the replica of the application source
code annotated with code coverage information.


%package        devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}


%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.


%prep
%setup -q -n bisect-%{version}
%patch0 -p1


%build
make PATH_OCAML_BIN=%{_bindir} all


# Works when run by hand, fails from rpmbuild.  Probably a tty issue.
#%check
#make PATH_OCAML_BIN=%{_bindir} tests


%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_libdir}/ocaml/bisect

install -m 0755 bin/bisect-report.opt \
  $RPM_BUILD_ROOT%{_bindir}/bisect-report
strip $RPM_BUILD_ROOT%{_bindir}/bisect-report

install -m 0644 bin/*.{a,cmi,cma,cmx,cmxa} \
  $RPM_BUILD_ROOT%{_libdir}/ocaml/bisect


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc COPYING
%{_bindir}/bisect-report
%{_libdir}/ocaml/bisect
%if %opt
%exclude %{_libdir}/ocaml/bisect/*.a
%exclude %{_libdir}/ocaml/bisect/*.cmxa
%exclude %{_libdir}/ocaml/bisect/*.cmx
%endif


%files devel
%defattr(-,root,root,-)
%doc CHANGES COPYING README VERSION doc/bisect.pdf ocamldoc
%if %opt
%{_libdir}/ocaml/bisect/*.a
%{_libdir}/ocaml/bisect/*.cmxa
%{_libdir}/ocaml/bisect/*.cmx
%endif


%changelog
* Tue Jan  5 2010 Richard W.M. Jones <rjones@redhat.com> - 1.0-1
- Update to non-alpha 1.0 (requested by upstream author).
- Use upstream RPM 4.8 OCaml dependency generator.
- Use %%global instead of %%define.
- Define PATH_OCAML_BIN to work around strangeness in Makefile.
- Remove nojava patch.
- Add patch to fix build of thread code.
- Rechecked in rpmlint.

* Wed Dec 30 2009 Richard W.M. Jones <rjones@redhat.com> - 1.0-0.7.alpha
- Rebuild for OCaml 3.11.2.

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0-0.6.alpha
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Sat May 23 2009 Richard W.M. Jones <rjones@redhat.com> - 1.0-0.5.alpha
- Rebuild for OCaml 3.11.1

* Thu Apr 16 2009 S390x secondary arch maintainer <fedora-s390x@lists.fedoraproject.org>
- ExcludeArch sparc64, s390, s390x as we don't have OCaml on those archs
  (added sparc64 per request from the sparc maintainer)

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0-0.4.alpha
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Nov 26 2008 Richard W.M. Jones <rjones@redhat.com> - 1.0-0.3.alpha
- Rebuild for OCaml 3.11.0+rc1.

* Wed Nov 19 2008 Richard W.M. Jones <rjones@redhat.com> - 1.0-0.2.alpha
- Rebuild for OCaml 3.11.0

* Sun Aug 24 2008 Richard W.M. Jones <rjones@redhat.com> - 1.0-0.1.alpha
- Initial RPM release.
